#!/bin/bash
#: Title      : test_masklbl
#: Date       : 2018-02-16
#: Author     : "Vesa Oikonen" <vesa.oikonen@utu.fi>
#: Options    : None

# Set the name of executable to test
if [ -n "${OS+1}" ] && [ "$OS" = "Windows_NT" ]; then
EXT=.exe;
else
EXT=;
fi
PROGRAM=../../masklbl$EXT;

if [ ! -f $PROGRAM ]; then
  printf "Failed: executable does not exist.\n"
  exit 1
fi

printf "=====================================================================\n"
printf "creating test data for %s\n" $PROGRAM
printf "=====================================================================\n"


printf "\n verifying that required data exists \n"


printf "\n make 3D test data\n"

if [ ! -f mask3d.v ] || [ ! -f mask3d.img ]; then

  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n"  > tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  asc2flat tmp.dat tmp.bin
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
  flat2img -scanner=HRRT tmp.bin p1.v 1 1 16 16
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi

  printf "0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0\n"  > tmp.dat
  printf "0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 2 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 3 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  asc2flat tmp.dat tmp.bin
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
  flat2img -scanner=HRRT tmp.bin p2.v 1 1 16 16
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi

  printf "0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0\n"  > tmp.dat
  printf "0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 3 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  printf "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0\n" >> tmp.dat
  asc2flat tmp.dat tmp.bin
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
  flat2img -scanner=HRRT tmp.bin p3.v 1 1 16 16
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi

  imgadd mask3d.v p1.v p1.v p1.v p2.v p3.v p1.v p1.v p1.v
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
  img2tif -rb mask3d.v
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi

  e7to63 mask3d.v mask3d.img
  if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
fi



printf "\n\n"
printf "=====================================================================\n"
printf "testing %s\n" $PROGRAM
printf "=====================================================================\n"




printf "\n 1.0.0 \n"
printf " Test case: 3D matrix in ECAT 7 format. \n"
printf " Expected result: Correctly labelled. \n\n"

cp -f mask3d.v output.v
$PROGRAM output.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"
img2tif -rb output.v output_1_0_0.tif
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"
imgcalc output.v - 1 test.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgcutof -zero test.v 0 100
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgmatch -abs=0.0001 mask3d.v test.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n passed. \n\n"


printf "\n 1.0.1 \n"
printf " Test case: 3D matrix in ECAT 6 format. \n"
printf " Expected result: Correctly labelled. \n\n"

cp -f mask3d.img output.img
$PROGRAM output.img
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"
imgcalc output.img - 1 test.img
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgcutof -zero test.img 0 100
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgmatch -header=n -abs=0.0001 mask3d.v test.img
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n passed. \n\n"


printf "\n 1.0.2 \n"
printf " Test case: 3D matrix in NIfTI format. \n"
printf " Expected result: Correctly labelled. \n\n"

rm -f nifti/* output/* output.v test.v
rmdir nifti
ecat2nii -sif -o=nifti mask3d.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"

$PROGRAM nifti/mask3d.nii
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"
nii2ecat -o=output nifti/mask3d.nii
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"

imgcalc output/mask3d.v - 1 test.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgcutof -zero test.v 0 100
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgmatch -header=n -abs=0.0001 mask3d.v test.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n passed. \n\n"


printf "\n 1.0.3 \n"
printf " Test case: 3D matrix in Analyze format. \n"
printf " Expected result: Correctly labelled. \n\n"

rm -f anal/* output/* output.v test.v
rmdir anal
ecat2ana -sif -o=anal mask3d.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"

$PROGRAM anal/mask3d
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"
ana2ecat -o=output anal/mask3d
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n ok \n"

imgcalc output/mask3d.v - 1 test.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgcutof -zero test.v 0 100
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
imgmatch -header=n -abs=0.0001 mask3d.v test.v
if [ $? -ne 0 ] ; then printf "Failed!\n" ; exit 1 ; fi
printf "\n passed. \n\n"




printf "\n===================================================================\n"
printf "   All passed! \n"
printf "===================================================================\n"
exit 0


