TPCCLIB v1 documentation                                             {#mainpage}
========================

Folder v1 contains the C libraries and CLI applications that have been developed 
in [Turku PET Centre](http://www.turkupetcentre.fi/) from year 1991, 
and are now updated to compile with [CMake](http://www.cmake.org) 
cross-platform build environment in Linux, Mac OS X, and MS Windows 
(with msys and mingw-w64). 

Library functions in v1 are not formally tested, but applications have at least 
some basic tests included, and since they are already used for a long time, 
they are generally working reliably.

Contents of this library will be (slowly) migrated into 
[v2 library](../v2/index.html).

## Libraries in v1 ##

- libtpccurveio (libtpccurveio.h): Regional and input time-activity curve (TAC) IO.
- libtpcidi (libtpcidi.h): Image-derived input (IDI).
- libtpcimgio (libtpcimgio.h): PET image IO.
- libtpcimgp (libtpcimgp.h): PET image (IMG) processing.
- libtpcmisc (libtpcmisc.h): Miscellaneous routines.
- libtpcmodel (libtpcmodel.h): General modeling.
- libtpcmodext (libtpcmodext.h): PET data specific modeling.
- libtpcrec (libtpcrec.h): PET image reconstruction.
- libtpcroi (libtpcroi.h): PET image ROI IO.
- libtpcsvg (libtpcsvg.h): Scalable Vector Graphics (SVG) files from PET related data.

[Back to TPCCLIB](../index.html).

