/** @file tpcbfm.h
 *  @brief Header file for libtpcbfm.
 *  @details Header file for template library libtpcbfm.
 *  @author Vesa Oikonen
 *  @copyright (c) Turku PET Centre
 */
#ifndef _TPCBFM_H_
#define _TPCBFM_H_
/*****************************************************************************/

/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
/*****************************************************************************/
#include "tpcextensions.h"
#include "tpccm.h"
#include "tpctac.h"
/*****************************************************************************/

/*****************************************************************************/
/* bf_radiowater */
int bfmRadiowater(
  TAC *input, TAC *tissue, const int bfNr, const double k2min,
  const double k2max, TAC *bf, TPCSTATUS *status
);
/*****************************************************************************/

/*****************************************************************************/
/* bf_srtm */
int bfmSRTM(
  double *t, double *cri, const int n, const int bfNr,
  const double t3min, const double t3max, TAC *bf,
  TPCSTATUS *status
);
/*****************************************************************************/

/*****************************************************************************/
#endif /* TPCBFM */
