/** @file tpcfileutil.h
 *  @brief Header file for libtpcfileutil.
 *  @details Header file for template library libtpcfilenew. 
 *   Requires POSIX compatible compiler.
 *   The idea is to isolate POSIX dependent functions from most of the code base
 *   to allow easier code changes when necessary.
 *  @author Vesa Oikonen
 */
#ifndef _TPCFILEUTIL_H_
#define _TPCFILEUTIL_H_
/*****************************************************************************/

/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>
/*****************************************************************************/
/* For Windows/MinGW */
#ifdef HAVE_DIRECT_H
#include <direct.h>
#endif
/*****************************************************************************/
#include "tpcextensions.h"
#include "tpcift.h"
/*****************************************************************************/

/*****************************************************************************/
/* backup */
int fileBackup(const char *filename, const char *backup_ext, char *status);
/* filexist */
int fileExist(const char *filename);
unsigned short int pathFileNr(const char *pathname);
unsigned short int pathFileList(const char *pathname, IFT *ift);
/* pathexist */
int pathExist(const char *pathname);
int pathRemove(const char *pathname);
int pathCreate(const char *pathname);
/*****************************************************************************/

/*****************************************************************************/
#endif /* TPCFILEUTIL */
