/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include "tpcextensions.h"
#include "test_tpcnlopt.h"
/*****************************************************************************/

/*****************************************************************************/
int test_nloptRandomPoint(
  TPCSTATUS *status
) {
  int verbose=0; if(status!=NULL) verbose=status->verbose;
  statusSet(status, __func__, __FILE__, __LINE__, 0);
  if(verbose>0) {
    printf("\n=====================================\n");
    printf("\n%s\n", __func__);
    printf("\n=====================================\n");
  }

  int i, ret;
  double p[100], low[100], up[100];

  if(verbose>1) printf("\ncalling function with empty input\n");
  ret=nloptRandomPoint(NULL, NULL, NULL, 10);
  if(ret==0) return(1);
  if(verbose>2) printf("  -> error returned, which is good\n");
  ret=nloptRandomPoint(p, low, up, 0);
  if(ret!=0) return(2);
  if(verbose>2) printf("  -> error not returned, which is good\n");

  if(verbose>1) printf("\nnormal input\n");
  i=0; low[i]=0.0; up[i]=10.0;
  i=1; low[i]=0.0; up[i]=0.0;
  i=2; low[i]=10.0; up[i]=10.0;
  i=3; low[i]=-10.0; up[i]=0.0;
  i=4; low[i]=1.0E-06; up[i]=2.0E-06;
  ret=nloptRandomPoint(p, low, up, 5);
  if(ret!=0) return(10);
  for(i=0; i<5; i++) if(p[i]<low[i] || p[i]>up[i]) return(11);
  if(verbose>2) printf("  -> ok\n");

  return(0);
}
/*****************************************************************************/

/*****************************************************************************/
