#ifndef _TEST_TPCNLOPT_H_
#define _TEST_TPCNLOPT_H_
/*****************************************************************************/

/*****************************************************************************/
#include "tpcclibConfig.h"
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
/*****************************************************************************/
#include "tpcnlopt.h"
/*****************************************************************************/

/*****************************************************************************/
/* nlopt */
int test_nloptInit(TPCSTATUS *status);
int test_nloptFree(TPCSTATUS *status);
int test_nloptAllocate(TPCSTATUS *status);
int test_nloptDuplicate(TPCSTATUS *status);
int test_nloptLimitFixedNr(TPCSTATUS *status);
int test_nloptFixedNr(TPCSTATUS *status);
int test_nloptRemoveEmpties(TPCSTATUS *status);
/* Test functions */
double nloptDejong2(int n, double *x, void *func_data);
double nloptRastrigin(int n, double *x, void *func_data);
double nloptRastrigin1(int n, double *x, void *func_data);
/*****************************************************************************/

/*****************************************************************************/
/* constraints */
int test_nloptCheckParameters(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* rndpoint */
int test_nloptRandomPoint(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* simplex */
int test_nloptSimplex(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* praxis */
int test_nloptPowellBrent(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* mpso */
int test_nloptMPSO(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
/* tgo */
int test_nloptITGO1(TPCSTATUS *status);
int test_nloptITGO2(TPCSTATUS *status);
int test_nloptIATGO(TPCSTATUS *status);
/*****************************************************************************/

/*****************************************************************************/
#endif /* TEST_TPCNLOPT */
